﻿/*
 * Copyright 2011 Arne Vajhøj.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License. 
 */

using System;

using NUnit.Framework;

using Vajhoej.StaticWeaver;

namespace Test
{
    [TestFixture]
    public class TestAttributes
    {
        [Test]
        public void TestAspect()
        {
            AspectAttribute aa = (AspectAttribute)Attribute.GetCustomAttribute(typeof(TestAspect), typeof(AspectAttribute));
            Assert.IsNotNull(aa, "aspect");
        }
        [Test]
        public void TestPointcut()
        {
            PointcutAttribute pa = (PointcutAttribute)Attribute.GetCustomAttribute(typeof(TestAspect).GetMethod("TestPointcut"), typeof(PointcutAttribute));
            Assert.IsNotNull(pa, "pointcut");
            Assert.AreEqual("* *::*(*)", pa.Signature, "signature");
        }
        [Test]
        public void TestAdvice()
        {
            BeforeCallAdviceAttribute bcaa = (BeforeCallAdviceAttribute)Attribute.GetCustomAttribute(typeof(TestAspect).GetMethod("TestAdvice"), typeof(BeforeCallAdviceAttribute));
            Assert.IsNotNull(bcaa, "before call advice");
            Assert.AreEqual("TestPointcut", bcaa.Pointcut, "pointcut");
            AfterCallAdviceAttribute acaa = (AfterCallAdviceAttribute)Attribute.GetCustomAttribute(typeof(TestAspect).GetMethod("TestAdvice"), typeof(AfterCallAdviceAttribute));
            Assert.IsNotNull(acaa, "before call advice");
            Assert.AreEqual("TestPointcut", acaa.Pointcut, "pointcut");
        }
    }
}
